/* :set tabstop=4													*/
/*
 * $Header: defs.h,v 1.1 86/04/20 16:16:52 sysad Exp $
 */

/*
 * $Log:	defs.h,v $
 * Revision 1.1  86/04/20  16:16:52  sysad
 * Initial distribution version
 * 
 * 
 */


/* It is the intent of the author that this software may be distributed
 * and used freely, without restriction.  If you make improvements or
 * enhancements, I would appreciate a copy.
 *
 * Duane H. Hesser	Teltone Corporation
 * ....uw-beaver!tikal!sysad
 * ....uw-beaver!tikal!dhh
 */

#ifndef QUICKPLOT
#define	GRAPHICSCHAR	'\005'	/* puts printer in graphics mode	*/
#define	XPERINCH	((double)60.0)		/* horizontal dot density	*/
#define	YPERINCH	((double)72.0)		/* vertical dot density		*/
#define	SPACEX	((8 * XPERINCH) - 1)	/* dots for 8 inch plot area*/
#define	SPACEY	((8 * YPERINCH)	- 1)	/* dots for 8 inch plot area*/
#define	XDOTS	792				/* maximum possible horizontal dots	*/
/* we lose 12 dots vertically with the print head positioned for
 * printing on the first line in ascii mode
 */
#define	YDOTS	780				/* maximum possible vertical dots	*/
#define	XBYTES	(XDOTS/6)		/* bytes needed for XDOTS			*/
#define	MAXX	(XDOTS - 1)		/* maximum plottable x value		*/
#define	MAXY	(YDOTS - 1)		/* maximum plottable y value		*/
#else
#define	PLOTCHAR	'X'			/* use this char for plotting		*/
#define	XPERINCH	((double)10.0)		/* horizontal dot density	*/
#define	YPERINCH	((double)6.0)		/* vertical dot density		*/
#define	SPACEX	((8 * XPERINCH) - 1)	/* dots for 8 inch plot area*/
#define	SPACEY	((8 * YPERINCH)	- 1)	/* dots for 8 inch plot area*/
#define	XDOTS	132				/* maximum possible horizontal dots	*/
#define	YDOTS	66				/* maximum possible vertical dots	*/
#define	XBYTES	(XDOTS)			/* horizontal dimension of array	*/
#define	MAXX	(XDOTS - 1)		/* maximum plottable x value		*/
#define	MAXY	(YDOTS - 1)		/* maximum plottable y value		*/
#endif

/* Horizontal dimension of Row array.
 * Add 1 byte for a null, 1 for LF, 1 for graphics byte
 */
#define	XARRAYSIZE	(XBYTES + 3)

/* Linemode masks; used in make_line() for lplot					*/
#define	SOLID 0177777
#define	DOTTED 001
#define	SHORTDASHED 003
#define	DOTDASHED 013
#define	LONGDASHED 007

#ifndef QUICKPLOT
#define	mapx(x)	((((double)x - lowx_space) * mapxfac) + Xmargin + 0.5)
#define	mapy(y)	((((double)y - lowy_space) * mapyfac) + Ymargin + 0.5)
#define	plotbit(x,a)	(x & (1 << a))
#else
#define	mapx(x)	((((double)x - lowx_space) * mapxfac) + Xmargin + 0.01)
#define	mapy(y)	((((double)y - lowy_space) * mapyfac) + Ymargin + 0.01)
#endif
